Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diaar5.F90	(revision 2528)
@@ -4,5 +4,6 @@
    !! AR5 diagnostics
    !!======================================================================
-   !! History : 3.2  !  2009-11  (S. Masson)  Original code
+   !! History :  3.2  !  2009-11  (S. Masson)  Original code
+   !!            3.3  !  2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase + merge TRC-TRA
    !!----------------------------------------------------------------------
 #if defined key_diaar5
@@ -10,11 +11,10 @@
    !!   'key_diaar5'  :                           activate ar5 diagnotics
    !!----------------------------------------------------------------------
-   !!   exa_mpl       : liste of module subroutine (caution, never use the
-   !!   exa_mpl_init  : name of the module for a routine)
-   !!   exa_mpl_stp   : Please try to use 3 letter block for routine names
+   !!   dia_ar5       : AR5 diagnostics
+   !!   dia_ar5_init  : initialisation of AR5 diagnostics
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and active tracers 
    USE dom_oce        ! ocean space and time domain
-   USE eosbn2          ! equation of state                (eos_bn2 routine)
+   USE eosbn2         ! equation of state                (eos_bn2 routine)
    USE lib_mpp        ! distribued memory computing library
    USE iom            ! I/O manager library
@@ -23,22 +23,22 @@
    PRIVATE
 
-   PUBLIC   dia_ar5   ! routine called in step.F90 module
+   PUBLIC   dia_ar5        ! routine called in step.F90 module
+   PUBLIC   dia_ar5_init   ! routine called in opa.F90 module
 
    LOGICAL, PUBLIC, PARAMETER :: lk_diaar5 = .TRUE.   ! coupled flag
 
-   REAL(wp)                         ::   vol0               ! ocean volume (interior domain)
-   REAL(wp)                         ::   area_tot           ! total ocean surface (interior domain)
-   REAL(wp), DIMENSION(jpi,jpj    ) ::   area               ! cell surface (interior domain)
-   REAL(wp), DIMENSION(jpi,jpj    ) ::   thick0             ! ocean thickness (interior domain)
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   sn0                ! initial salinity
+   REAL(wp)                         ::   vol0         ! ocean volume (interior domain)
+   REAL(wp)                         ::   area_tot     ! total ocean surface (interior domain)
+   REAL(wp), DIMENSION(jpi,jpj    ) ::   area         ! cell surface (interior domain)
+   REAL(wp), DIMENSION(jpi,jpj    ) ::   thick0       ! ocean thickness (interior domain)
+   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   sn0          ! initial salinity
       
    !! * Substitutions
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -47,16 +47,6 @@
       !!                    ***  ROUTINE dia_ar5  ***
       !!
-      !! ** Purpose :   Brief description of the routine
+      !! ** Purpose :   compute and output some AR5 diagnostics
       !!
-      !! ** Method  :   description of the methodoloy used to achieve the
-      !!                objectives of the routine. Be as clear as possible!
-      !!
-      !! ** Action  : - first action (share memory array/varible modified
-      !!                in this routine
-      !!              - second action .....
-      !!              - .....
-      !!
-      !! References :   Author et al., Short_name_review, Year
-      !!                Give references if exist otherwise suppress these lines
       !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -66,7 +56,6 @@
       REAL(wp), DIMENSION(jpi,jpj    ) ::   zarea_ssh, zbotpres
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zrhd, zrhop
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jpts) ::   ztsn
       !!--------------------------------------------------------------------
-
-      IF( kt == nit000  )   CALL dia_ar5_init   ! Initialization (first time-step only)
 
       CALL iom_put( 'cellthc', fse3t(:,:,:) )
@@ -83,11 +72,13 @@
 
       !                                         ! thermosteric ssh
-      CALL eos( tn, sn0, zrhd )                       ! now in situ density using initial salinity
-      !
-      zbotpres(:,:) = 0.e0                            ! no atmospheric surface pressure, levitating sea-ice
+      ztsn(:,:,:,jp_tem) = tn (:,:,:)
+      ztsn(:,:,:,jp_sal) = sn0(:,:,:)
+      CALL eos( ztsn, zrhd )                       ! now in situ density using initial salinity
+      !
+      zbotpres(:,:) = 0._wp                        ! no atmospheric surface pressure, levitating sea-ice
       DO jk = 1, jpkm1
          zbotpres(:,:) = zbotpres(:,:) + fse3t(:,:,jk) * zrhd(:,:,jk)
       END DO
-      IF( .NOT. lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
+      IF( .NOT.lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
       !                                         
       zarho = SUM( area(:,:) * zbotpres(:,:) ) 
@@ -97,13 +88,13 @@
       
       !                                         ! steric sea surface height
-      CALL eos( tn, sn, zrhd, zrhop )                 ! now in situ and potential density
-      zrhop(:,:,jpk) = 0.e0
+      CALL eos( tsn, zrhd, zrhop )                 ! now in situ and potential density
+      zrhop(:,:,jpk) = 0._wp
       CALL iom_put( 'rhop', zrhop )
       !
-      zbotpres(:,:) = 0.e0                            ! no atmospheric surface pressure, levitating sea-ice
+      zbotpres(:,:) = 0._wp                        ! no atmospheric surface pressure, levitating sea-ice
       DO jk = 1, jpkm1
          zbotpres(:,:) = zbotpres(:,:) + fse3t(:,:,jk) * zrhd(:,:,jk)
       END DO
-      IF( .NOT. lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
+      IF( .NOT.lk_vvl )   zbotpres(:,:) = zbotpres(:,:) + sshn(:,:) * zrhd(:,:,1)
       !    
       zarho = SUM( area(:,:) * zbotpres(:,:) ) 
@@ -113,23 +104,23 @@
       
       !                                         ! ocean bottom pressure
-      zztmp = rau0 * grav * 1.e-4                     ! recover pressure from pressure anomaly and cover to dbar = 1.e4 Pa
+      zztmp = rau0 * grav * 1.e-4_wp               ! recover pressure from pressure anomaly and cover to dbar = 1.e4 Pa
       zbotpres(:,:) = zztmp * ( zbotpres(:,:) + sshn(:,:) + thick0(:,:) )
       CALL iom_put( 'botpres', zbotpres )
 
       !                                         ! Mean density anomalie, temperature and salinity
-      ztemp = 0.e0
-      zsal  = 0.e0
+      ztemp = 0._wp
+      zsal  = 0._wp
       DO jk = 1, jpkm1
          DO jj = 1, jpj
             DO ji = 1, jpi
                zztmp = area(ji,jj) * fse3t(ji,jj,jk)
-               ztemp = ztemp + zztmp * tn  (ji,jj,jk)
-               zsal  = zsal  + zztmp * sn  (ji,jj,jk)
+               ztemp = ztemp + zztmp * tn(ji,jj,jk)
+               zsal  = zsal  + zztmp * sn(ji,jj,jk)
             END DO
          END DO
       END DO
-      IF( .NOT. lk_vvl ) THEN
-         ztemp = ztemp + SUM( zarea_ssh(:,:) * tn  (:,:,1) )
-         zsal  = zsal  + SUM( zarea_ssh(:,:) * sn  (:,:,1) )
+      IF( .NOT.lk_vvl ) THEN
+         ztemp = ztemp + SUM( zarea_ssh(:,:) * tn(:,:,1) )
+         zsal  = zsal  + SUM( zarea_ssh(:,:) * sn(:,:,1) )
       ENDIF
       IF( lk_mpp ) THEN  
@@ -153,11 +144,5 @@
       !!                  ***  ROUTINE dia_ar5_init  ***
       !!                   
-      !! ** Purpose :   initialization of ....
-      !!
-      !! ** Method  :   blah blah blah ...
-      !!
-      !! ** input   :   Namlist namexa
-      !!
-      !! ** Action  :   ...  
+      !! ** Purpose :   initialization for AR5 diagnostic computation
       !!----------------------------------------------------------------------
       INTEGER  ::   inum
@@ -172,6 +157,6 @@
       area_tot = SUM( area(:,:) )   ;   IF( lk_mpp )   CALL mpp_sum( area_tot )
 
-      vol0        = 0.e0
-      thick0(:,:) = 0.e0
+      vol0        = 0._wp
+      thick0(:,:) = 0._wp
       DO jk = 1, jpkm1
          vol0        = vol0        + SUM( area (:,:) * tmask(:,:,jk) * fse3t_0(:,:,jk) )
@@ -184,13 +169,13 @@
       CALL iom_get  ( inum, jpdom_data, 'vosaline', zsaldta(:,:,:,2), 12 )
       CALL iom_close( inum )
-      sn0(:,:,:) = 0.5 * ( zsaldta(:,:,:,1) + zsaldta(:,:,:,2) )        
-      sn0(:,:,:) = sn0(:,:,:)*tmask(:,:,:)
+      sn0(:,:,:) = 0.5_wp * ( zsaldta(:,:,:,1) + zsaldta(:,:,:,2) )        
+      sn0(:,:,:) = sn0(:,:,:) * tmask(:,:,:)
       IF( ln_zps ) THEN               ! z-coord. partial steps
          DO jj = 1, jpj               ! interpolation of salinity at the last ocean level (i.e. the partial step)
             DO ji = 1, jpi
-               ik = mbathy(ji,jj) - 1
-               IF( ik > 2 ) THEN
+               ik = mbkt(ji,jj)
+               IF( ik > 1 ) THEN
                   zztmp = ( gdept_0(ik) - fsdept_0(ji,jj,ik) ) / ( gdept_0(ik) - gdept_0(ik-1) )
-                  sn0(ji,jj,ik) = (1.-zztmp) * sn0(ji,jj,ik) + zztmp * sn0(ji,jj,ik-1)
+                  sn0(ji,jj,ik) = ( 1._wp - zztmp ) * sn0(ji,jj,ik) + zztmp * sn0(ji,jj,ik-1)
                ENDIF
             END DO
@@ -204,11 +189,10 @@
    !!   Default option :                                         NO diaar5
    !!----------------------------------------------------------------------
-
    LOGICAL, PUBLIC, PARAMETER :: lk_diaar5 = .FALSE.   ! coupled flag
-
 CONTAINS
-
+   SUBROUTINE dia_ar5_init    ! Dummy routine
+   END SUBROUTINE dia_ar5_init
    SUBROUTINE dia_ar5( kt )   ! Empty routine
-      INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
+      INTEGER ::   kt
       WRITE(*,*) 'dia_ar5: You should not have seen this print! error?', kt
    END SUBROUTINE dia_ar5
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diadimg.F90	(revision 2528)
@@ -20,8 +20,9 @@
    !! * Substitutions
 #  include "domzgr_substitute.h90"
-   !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diafwb.F90	(revision 2528)
@@ -8,7 +8,7 @@
    !!            9.0  !  05-11  (V. Garnier) Surface pressure gradient organization
    !!----------------------------------------------------------------------
-#if ( defined key_orca_r2 || defined  key_orca_r4 )  && ! defined key_coupled
-   !!----------------------------------------------------------------------
-   !!   "key_orca_r2 or 4"
+#if (  defined key_orca_r1 || defined key_orca_r2 || defined  key_orca_r4 ) && ! defined key_coupled
+   !!----------------------------------------------------------------------
+   !!   "key_orca_r1 or 2 or 4"
    !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
@@ -30,5 +30,5 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_diafwb = .TRUE.    !: fresh water budget flag
 
-   REAL(wp)               ::   a_emp ,          &
+   REAL(wp)               ::   a_fwf ,          &
       &                        a_sshb, a_sshn, a_salb, a_saln
    REAL(wp), DIMENSION(4) ::   a_flxi, a_flxo, a_temi, a_temo, a_sali, a_salo
@@ -38,7 +38,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -59,5 +59,5 @@
       REAL(wp) ::  ztemi(4), ztemo(4), zsali(4), zsalo(4), zflxi(4), zflxo(4)
       REAL(wp) ::  zt, zs, zu  
-      REAL(wp) ::  zsm0, zempnew
+      REAL(wp) ::  zsm0, zfwfnew
       !!----------------------------------------------------------------------
 
@@ -65,9 +65,9 @@
       zsm0 = 34.72654
 
-      ! To compute emp mean value mean emp
+      ! To compute fwf mean value mean fwf
 
       IF( kt == nit000 ) THEN
 
-         a_emp    = 0.e0
+         a_fwf    = 0.e0
          a_sshb   = 0.e0 ! valeur de ssh au debut de la simulation
          a_salb   = 0.e0 ! valeur de sal au debut de la simulation
@@ -87,6 +87,6 @@
       ENDIF
       
-      a_emp    = SUM( e1t(:,:) * e2t(:,:) * emp   (:,:) * tmask_i(:,:) )
-      IF( lk_mpp )   CALL mpp_sum( a_emp    )       ! sum over the global domain
+      a_fwf    = SUM( e1t(:,:) * e2t(:,:) * ( emp(:,:)-rnf(:,:) ) * tmask_i(:,:) ) 
+      IF( lk_mpp )   CALL mpp_sum( a_fwf    )       ! sum over the global domain
 
       IF( kt == nitend ) THEN
@@ -95,5 +95,5 @@
          zarea = 0.e0
          zvol  = 0.e0
-         zempnew = 0.e0
+         zfwfnew = 0.e0
          ! Mean sea level at nitend
          a_sshn = SUM( e1t(:,:) * e2t(:,:) * sshn(:,:) * tmask_i(:,:) )
@@ -115,8 +115,8 @@
          
          ! Conversion in m3
-         a_emp    = a_emp * rdttra(1) * 1.e-3 
+         a_fwf    = a_fwf * rdttra(1) * 1.e-3 
          
-         ! emp correction to bring back the mean ssh to zero
-         zempnew = a_sshn / ( ( nitend - nit000 + 1 ) * rdt ) * 1.e3 / zarea
+         ! fwf correction to bring back the mean ssh to zero
+         zfwfnew = a_sshn / ( ( nitend - nit000 + 1 ) * rdt ) * 1.e3 / zarea
 
       ENDIF
@@ -162,4 +162,9 @@
             ii0 = 140   ;   ii1 = 140
             ij0 = 102   ;   ij1 = 102
+            !                                        ! =======================
+         CASE ( 1 )                                  !  ORCA_R1 configurations
+            !                                        ! =======================
+            ii0 = 283   ;   ii1 = 283
+            ij0 = 200   ;   ij1 = 200
             !                                        ! =======================
          CASE DEFAULT                                !    ORCA R05 or R025
@@ -204,4 +209,9 @@
             ii0 = 137   ;   ii1 = 137
             ij0 = 101   ;   ij1 = 102
+            !                                        ! =======================
+         CASE ( 1 )                                  !  ORCA_R1 configurations
+            !                                        ! =======================
+            ii0 = 282   ;   ii1 = 282
+            ij0 = 200   ;   ij1 = 200
             !                                        ! =======================
          CASE DEFAULT                                !    ORCA R05 or R025
@@ -247,4 +257,9 @@
             ij0 = 88    ;   ij1 = 88 
             !                                        ! =======================
+         CASE ( 1 )                                  !  ORCA_R1 configurations
+            !                                        ! =======================
+            ii0 = 331   ;   ii1 = 331
+            ij0 = 176   ;   ij1 = 176
+            !                                        ! =======================
          CASE DEFAULT                                !    ORCA R05 or R025
             !                                        ! =======================
@@ -289,4 +304,9 @@
             ij0 = 116   ;   ij1 = 116
             !                                        ! =======================
+         CASE ( 1 )                                  !  ORCA_R1 configurations
+            !                                        ! =======================
+            ii0 = 297   ;   ii1 = 297 
+            ij0 = 230   ;   ij1 = 230
+            !                                        ! =======================
          CASE DEFAULT                                !    ORCA R05 or R025
             !                                        ! =======================
@@ -362,5 +382,5 @@
          WRITE(inum,*)
          WRITE(inum,*)    'Net freshwater budget '
-         WRITE(inum,9010) '  emp    = ',a_emp,   ' m3 =', a_emp   /(FLOAT(nitend-nit000+1)*rdttra(1)) * 1.e-6,' Sv'
+         WRITE(inum,9010) '  fwf    = ',a_fwf,   ' m3 =', a_fwf   /(FLOAT(nitend-nit000+1)*rdttra(1)) * 1.e-6,' Sv'
          WRITE(inum,*)
          WRITE(inum,9010) '  zarea =',zarea
Index: trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/DIA/diahsb.F90	(revision 2528)
@@ -0,0 +1,265 @@
+MODULE diahsb
+   !!======================================================================
+   !!                       ***  MODULE  diahsb  ***
+   !! Ocean diagnostics: Heat, salt and volume budgets
+   !!======================================================================
+   !! History :  3.3  ! 2010-09  (M. Leclair)  Original code 
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! physical constants
+   USE sbc_oce         ! surface thermohaline fluxes
+   USE in_out_manager  ! I/O manager
+   USE domvvl          ! vertical scale factors
+   USE traqsr          ! penetrative solar radiation
+   USE trabbc          ! bottom boundary condition 
+   USE lib_mpp         ! distributed memory computing library
+   USE trabbc          ! bottom boundary condition
+   USE bdy_par         ! (for lk_bdy)
+   USE obc_par         ! (for lk_obc)
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   dia_hsb        ! routine called by step.F90
+   PUBLIC   dia_hsb_init   ! routine called by opa.F90
+
+   LOGICAL, PUBLIC ::   ln_diahsb  = .FALSE.   !: check the heat and salt budgets
+
+   INTEGER                                 ::   numhsb                           !
+   REAL(dp)                                ::   surf_tot   , vol_tot             !
+   REAL(dp)                                ::   frc_t      , frc_s     , frc_v   ! global forcing trends
+   REAL(dp)                                ::   fact1                            ! conversion factors
+   REAL(dp)                                ::   fact21    , fact22               !     -         -
+   REAL(dp)                                ::   fact31    , fact32               !     -         -
+   REAL(dp), DIMENSION(:,:)  , ALLOCATABLE ::   surf      , ssh_ini              !
+   REAL(dp), DIMENSION(:,:,:), ALLOCATABLE ::   hc_loc_ini, sc_loc_ini, e3t_ini  !
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE dia_hsb( kt )
+      !!---------------------------------------------------------------------------
+      !!                  ***  ROUTINE dia_hsb  ***
+      !!     
+      !! ** Purpose: Compute the ocean global heat content, salt content and volume conservation
+      !!	
+      !! ** Method : - Compute the deviation of heat content, salt content and volume
+      !!	            at the current time step from their values at nit000
+      !!	            - Compute the contribution of forcing and remove it from these deviations
+      !!
+      !! ** Action : Write the results in the 'heat_salt_volume_budgets.txt' ASCII file
+      !!---------------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !!
+      INTEGER    ::   jk                          ! dummy loop indice
+      REAL(dp)   ::   zdiff_hc    , zdiff_sc      ! heat and salt content variations
+      REAL(dp)   ::   zdiff_v1    , zdiff_v2      ! volume variation
+      REAL(dp)   ::   z1_rau0                     ! local scalars
+      REAL(dp)   ::   zdeltat                     !    -     -
+      REAL(dp)   ::   z_frc_trd_t , z_frc_trd_s   !    -     -
+      REAL(dp)   ::   z_frc_trd_v                 !    -     -
+      !!---------------------------------------------------------------------------
+
+      ! ------------------------- !
+      ! 1 - Trends due to forcing !
+      ! ------------------------- !
+      z1_rau0 = 1.e0 / rau0
+      z_frc_trd_v = z1_rau0 * SUM( - ( emp(:,:) - rnf(:,:) ) * surf(:,:) )     ! volume fluxes
+      z_frc_trd_t =           SUM( sbc_tsc(:,:,jp_tem) * surf(:,:) )     ! heat fluxes
+      z_frc_trd_s =           SUM( sbc_tsc(:,:,jp_sal) * surf(:,:) )     ! salt fluxes
+      ! Add penetrative solar radiation
+      IF( ln_traqsr )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qsr     (:,:) * surf(:,:) )
+      ! Add geothermal heat flux
+      IF( ln_trabbc )   z_frc_trd_t = z_frc_trd_t + ro0cpr * SUM( qgh_trd0(:,:) * surf(:,:) )
+      IF( lk_mpp ) THEN
+         CALL mpp_sum( z_frc_trd_v )
+         CALL mpp_sum( z_frc_trd_t )
+      ENDIF
+      frc_v = frc_v + z_frc_trd_v * rdt
+      frc_t = frc_t + z_frc_trd_t * rdt
+      frc_s = frc_s + z_frc_trd_s * rdt
+
+      ! ----------------------- !
+      ! 2 -  Content variations !
+      ! ----------------------- !
+      zdiff_v2 = 0.d0
+      zdiff_hc = 0.d0
+      zdiff_sc = 0.d0
+      ! volume variation (calculated with ssh)
+      zdiff_v1 = SUM( surf(:,:) * tmask(:,:,1) * ( sshn(:,:) - ssh_ini(:,:) ) )
+      DO jk = 1, jpkm1
+         ! volume variation (calculated with scale factors)
+         zdiff_v2 = zdiff_v2 + SUM( surf(:,:) * tmask(:,:,jk)   &
+            &                       * ( fse3t_n(:,:,jk)         &
+            &                           - e3t_ini(:,:,jk) ) )
+         ! heat content variation
+         zdiff_hc = zdiff_hc + SUM( surf(:,:) * tmask(:,:,jk)          &
+            &                       * ( fse3t_n(:,:,jk) * tn(:,:,jk)   &
+            &                           - hc_loc_ini(:,:,jk) ) )
+         ! salt content variation
+         zdiff_sc = zdiff_sc + SUM( surf(:,:) * tmask(:,:,jk)          &
+            &                       * ( fse3t_n(:,:,jk) * sn(:,:,jk)   &
+            &                           - sc_loc_ini(:,:,jk) ) )
+      ENDDO
+
+      IF( lk_mpp ) THEN
+         CALL mpp_sum( zdiff_hc )
+         CALL mpp_sum( zdiff_sc )
+         CALL mpp_sum( zdiff_v1 )
+         CALL mpp_sum( zdiff_v2 )
+      ENDIF
+
+      ! Substract forcing from heat content, salt content and volume variations
+      zdiff_v1 = zdiff_v1 - frc_v
+      zdiff_v2 = zdiff_v2 - frc_v
+      zdiff_hc = zdiff_hc - frc_t
+      zdiff_sc = zdiff_sc - frc_s
+      
+      ! ----------------------- !
+      ! 3 - Diagnostics writing !
+      ! ----------------------- !
+      zdeltat  = 1.e0 / ( ( kt - nit000 + 1 ) * rdt )
+      WRITE(numhsb , 9020) kt , zdiff_hc / vol_tot , zdiff_hc * fact1  * zdeltat,                                &
+         &                      zdiff_sc / vol_tot , zdiff_sc * fact21 * zdeltat, zdiff_sc * fact22 * zdeltat,   &
+         &                      zdiff_v1           , zdiff_v1 * fact31 * zdeltat, zdiff_v1 * fact32 * zdeltat,   &
+         &                      zdiff_v2           , zdiff_v2 * fact31 * zdeltat, zdiff_v2 * fact32 * zdeltat
+
+      IF ( kt == nitend ) CLOSE( numhsb )
+
+9020  FORMAT(I5,11D15.7)
+      !
+   END SUBROUTINE dia_hsb
+
+
+   SUBROUTINE dia_hsb_init
+      !!---------------------------------------------------------------------------
+      !!                  ***  ROUTINE dia_hsb  ***
+      !!     
+      !! ** Purpose: Initialization for the heat salt volume budgets
+      !!	
+      !! ** Method : Compute initial heat content, salt content and volume
+      !!
+      !! ** Action : - Compute initial heat content, salt content and volume
+      !!             - Initialize forcing trends
+      !!             - Compute coefficients for conversion
+      !!---------------------------------------------------------------------------
+      CHARACTER (len=32) ::   cl_name  ! output file name
+      INTEGER            ::   jk       ! dummy loop indice
+      INTEGER            ::   ierror   ! local integer
+      !!
+      NAMELIST/namhsb/ ln_diahsb
+      !!----------------------------------------------------------------------
+      !
+      REWIND ( numnam )              ! Read Namelist namhsb 
+      READ   ( numnam, namhsb )
+      !
+      IF(lwp) THEN                   ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'dia_hsb_init : check the heat and salt budgets'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '   Namelist namhsb : set hsb parameters'
+         WRITE(numout,*) '      Switch for hsb diagnostic (T) or not (F)  ln_diahsb  = ', ln_diahsb
+      ENDIF
+
+      IF( .NOT. ln_diahsb )   RETURN
+
+      ! ------------------- !
+      ! 1 - Allocate memory !
+      ! ------------------- !
+      ALLOCATE( hc_loc_ini(jpi,jpj,jpk), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'dia_hsb: unable to allocate hc_loc_ini' )   ;   RETURN
+      ENDIF
+      ALLOCATE( sc_loc_ini(jpi,jpj,jpk), STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'dia_hsb: unable to allocate sc_loc_ini' )   ;   RETURN
+      ENDIF
+      ALLOCATE( e3t_ini(jpi,jpj,jpk)   , STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'dia_hsb: unable to allocate e3t_ini' )      ;   RETURN
+      ENDIF
+      ALLOCATE( surf(jpi,jpj)          , STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'dia_hsb: unable to allocate surf' )         ;   RETURN
+      ENDIF
+      ALLOCATE( ssh_ini(jpi,jpj)       , STAT=ierror )
+      IF( ierror > 0 ) THEN
+         CALL ctl_stop( 'dia_hsb: unable to allocate ssh_ini' )      ;   RETURN
+      ENDIF
+
+      ! ----------------------------------------------- !
+      ! 2 - Time independant variables and file opening !
+      ! ----------------------------------------------- !
+      WRITE(numout,*) "dia_hsb: heat salt volume budgets activated"
+      WRITE(numout,*) "~~~~~~~  output written in the 'heat_salt_volume_budgets.txt' ASCII file"
+      IF( lk_obc .OR. lk_bdy) THEN
+         CALL ctl_warn( 'dia_hsb does not take open boundary fluxes into account' )         
+      ENDIF
+      cl_name    = 'heat_salt_volume_budgets.txt'                         ! name of output file
+      surf(:,:) = e1t(:,:) * e2t(:,:) * tmask(:,:,1) * tmask_i(:,:)      ! masked surface grid cell area
+      surf_tot  = SUM( surf(:,:) )                                       ! total ocean surface area
+      vol_tot   = 0.d0                                                   ! total ocean volume
+      DO jk = 1, jpkm1
+         vol_tot  = vol_tot + SUM( surf(:,:) * tmask(:,:,jk)     &
+            &                      * fse3t_n(:,:,jk)         )
+      END DO
+      IF( lk_mpp ) THEN 
+         CALL mpp_sum( vol_tot )
+         CALL mpp_sum( surf_tot )
+      ENDIF
+
+      CALL ctl_opn( numhsb , cl_name , 'UNKNOWN' , 'FORMATTED' , 'SEQUENTIAL' , 1 , numout , lwp , 1 )
+      !                   12345678901234567890123456789012345678901234567890123456789012345678901234567890 -> 80
+      WRITE( numhsb, 9010 ) "kt   |     heat content budget     |            salt content budget             ",   &
+         !                                                   123456789012345678901234567890123456789012345 -> 45
+         &                                                  "|            volume budget (ssh)             ",   &
+         !                                                   678901234567890123456789012345678901234567890 -> 45
+         &                                                  "|            volume budget (e3t)             "
+      WRITE( numhsb, 9010 ) "     |      [C]         [W/m2]     |     [psu]        [mmm/s]          [SV]     ",   &
+         &                                                  "|     [m3]         [mmm/s]          [SV]     ",   &
+         &                                                  "|     [m3]         [mmm/s]          [SV]     "
+
+      ! --------------- !
+      ! 3 - Conversions ! (factors will be multiplied by duration afterwards)
+      ! --------------- !
+
+      ! heat content variation   =>   equivalent heat flux:
+      fact1  = rau0 * rcp / surf_tot                                         ! [C*m3]   ->  [W/m2]
+      ! salt content variation   =>   equivalent EMP and equivalent "flow": 
+      fact21 = 1.e3  / ( soce * surf_tot )                                   ! [psu*m3] ->  [mm/s]
+      fact22 = 1.e-6 / soce                                                  ! [psu*m3] ->  [Sv]
+      ! volume variation         =>   equivalent EMP and equivalent "flow":
+      fact31 = 1.e3  / surf_tot                                              ! [m3]     ->  [mm/s]
+      fact32 = 1.e-6                                                         ! [m3]     ->  [SV]
+
+      ! ---------------------------------- !
+      ! 4 - initial conservation variables !
+      ! ---------------------------------- !
+      ssh_ini(:,:) = sshn(:,:)                               ! initial ssh
+      DO jk = 1, jpk
+         e3t_ini   (:,:,jk) = fse3t_n(:,:,jk)                ! initial vertical scale factors
+         hc_loc_ini(:,:,jk) = tn(:,:,jk) * fse3t_n(:,:,jk)   ! initial heat content
+         sc_loc_ini(:,:,jk) = sn(:,:,jk) * fse3t_n(:,:,jk)   ! initial salt content
+      END DO
+      frc_v = 0.d0                                           ! volume       trend due to forcing
+      frc_t = 0.d0                                           ! heat content   -    -   -    -   
+      frc_s = 0.d0                                           ! salt content   -    -   -    -         
+      !
+9010  FORMAT(A80,A45,A45)
+      !
+   END SUBROUTINE dia_hsb_init
+
+   !!======================================================================
+END MODULE diahsb
